"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wrapNewLineComment = exports.parseVueFromContent = exports.newLine = exports.checkHasClassComponent = exports.beforeValidate = void 0;
var _compilerSfc = require("@vue/compiler-sfc");
var t = _interopRequireWildcard(require("@babel/types"));
var _traverse = _interopRequireDefault(require("@babel/traverse"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var newLine = exports.newLine = 'REPLACE_FOR_NEW_LINE';
var parseVueFromContent = exports.parseVueFromContent = function parseVueFromContent(content) {
  var _parseVue = (0, _compilerSfc.parse)(content),
    descriptor = _parseVue.descriptor,
    errors = _parseVue.errors;
  if (errors.length > 0) {
    throw new Error(errors.join('\n'));
  }
  return descriptor;
};
var wrapNewLineComment = exports.wrapNewLineComment = function wrapNewLineComment(node) {
  if (!node) {
    return null;
  }
  node.leadingComments = [{
    type: 'CommentLine',
    value: newLine
  }];
  return node;
};
var beforeValidate = exports.beforeValidate = function beforeValidate(desc) {
  if (desc.scriptSetup) {
    return {
      isOk: false,
      content: '',
      errors: ['⚠ File is already setup']
    };
  }
  if (!desc.script) {
    return {
      isOk: false,
      content: '',
      errors: ['⚠ Vue file is not contain script']
    };
  }
  if (desc.script.lang !== 'ts') {
    return {
      isOk: false,
      content: '',
      errors: ['⚠ Vue file is not typescript']
    };
  }
  return {
    isOk: true,
    content: desc.script.content,
    errors: []
  };
};
var checkHasClassComponent = exports.checkHasClassComponent = function checkHasClassComponent(ast) {
  var hasClassComponent = false;
  (0, _traverse["default"])(ast, {
    ExportDefaultDeclaration: function ExportDefaultDeclaration(path) {
      var node = path.node.declaration;
      if (t.isClassDeclaration(node)) {
        hasClassComponent = true;
      }
    }
  });
  if (!hasClassComponent) {
    return {
      isOk: false,
      content: '',
      errors: ['⚠ File is not contain class component']
    };
  }
  return {
    isOk: true,
    content: '',
    errors: []
  };
};