import * as t from '@babel/types';
import { TransformPlugin } from './types';
declare const ConversionStore: {
    addPropName: (propName: string) => void;
    hasPropName: (propName: string) => boolean;
    setFlag: (flagName: string, value: boolean) => void;
    getFlag: (flagName: string) => boolean | undefined;
    clear: () => void;
    printStore: () => void;
    addImport: (source: string, key: string, isDefault?: boolean) => void;
    getImports: () => Map<string, Map<string, {
        value: string;
        isDefault: boolean;
    }>>;
    addBeforeSetupStatement: (node: t.Statement) => void;
    getBeforeSetupStatements: () => Set<t.Statement>;
    addSetupContextKey: (name: string) => void;
    getSetupContextKeys: () => Set<string>;
    addAfterSetupStatement: (node: t.Statement) => void;
    getAfterSetupStatements: () => Set<t.Statement>;
    addReturnStatement: (name: string, node: t.ObjectMethod | t.ObjectProperty | t.SpreadElement) => void;
    getReturnStatement: () => Map<string, t.ObjectMethod | t.ObjectProperty | t.SpreadElement>;
    addRef: (name: string) => void;
    hasRefName: (name: string) => boolean;
    addShortReturnStatementByName: (name: string) => void;
    addExcludeRef: (name: string) => void;
    hasExcludeRefsName: (name: string) => boolean;
    registerPlugin: (name: string, plugin: TransformPlugin) => void;
    getPlugins: () => TransformPlugin[];
    addProp: (propName: string, node: t.ObjectProperty) => void;
    getProps: () => Map<string, t.ObjectProperty>;
    addExcludesNamesImportSpecifier: (name: string) => void;
    getExcludesNamesImportSpecifier: () => Set<string>;
};
export default ConversionStore;
